#include "leavelock.h"
#include "sessiondbusregister.h"

LeaveLock::LeaveLock(QObject *parent) : QObject(parent)
{
    process = new QProcess();
    connect(process, &QProcess::readyReadStandardOutput, this, &LeaveLock::readOutput);
    connect(process, &QProcess::readChannelFinished, this, &LeaveLock::pingFinished);
}

LeaveLock::~LeaveLock() {
    if (process) {
        process->close();
        process->waitForFinished();
    }
}

bool LeaveLock::setPing(QString uuid, QString dev, bool on) {
//    if (!uid.isEmpty() || uid == uuid)
//        return false;
//    if (dev.isEmpty())
//        return false;
    if (!on) {
        process->close();
        manualCancel = true;
        return true;
    }
    manualCancel = false;
    uid = uuid;
    lockdev = dev;
    qDebug() << "================" << lockdev;
    QString cmd = "l2ping " + lockdev;
    process->start(cmd);
    return true;
}

void LeaveLock::readOutput() {
    Q_EMIT SYSDBUSMNG::getInstance()->pingTimeSignal(process->readAllStandardOutput());
}

void LeaveLock::pingFinished() {
    QByteArray errorMsg = process->readAllStandardError();
    QByteArray output = process->readAllStandardOutput();
    qDebug() << "<<<<<<<<<<<<<<" << output << errorMsg;
    if (!output.isEmpty()) {
        Q_EMIT SYSDBUSMNG::getInstance()->pingTimeSignal(output);
    }
    if (!errorMsg.isEmpty()) {
        Q_EMIT SYSDBUSMNG::getInstance()->pingTimeSignal(errorMsg);
        return;
    }
    if (manualCancel)
        Q_EMIT SYSDBUSMNG::getInstance()->pingTimeSignal(QString("ping out").toLatin1());
    else
        Q_EMIT SYSDBUSMNG::getInstance()->pingTimeSignal(QString("loss connect").toLatin1());
    manualCancel = false;
}
